/*
        alph: Piper program implementing and analysing traditional and
        historic c(ai)phers designed to be used in conjuction with other
        programs.

        Copyright (C) 2004  Corcalciuc V. Horia

        This library is free software; you can redistribute it and/or
        modify it under the terms of the GNU Lesser General Public
        License as published by the Free Software Foundation; either
        version 2.1 of the License, or (at your option) any later version.

        This library is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
        Lesser General Public License for more details.

        You should have received a copy of the GNU Lesser General Public
        License along with this library; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

*/

/* System includes */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

/* Errors */

#define KEYB	"Bad key"		/* bad key. */
#define ENTO	"Key entropy error"		/* entropy too short */
#define UNKN  "Unknown malfunction"		/* unkown fault */
#define MESS  "Message error" /* invalid message */
#define UNFL  "Bad file" /* bad IO file */

/* Error handler */
extern void fault(char *TYPE, char *problem);

/* Decrypt-Encrypt */

typedef enum
{
  false = 0,
  true
} DoE;

DoE al_dec, al_enc;

/* Cyphers */

extern char *caesar (char *org);					  /* CAESAR */
extern char *atbash (char *org);					  /* ATBASH */
extern char *zigzag (char *org);          /* ZIGZAG */
extern char *railfence(char *org, int key);  /* RAILFENCE */
extern char *rot13 (char *org);					  /* ROT-13 */
extern char *adfgx (char *org);            /* ADFGX */
extern char *vigenere (char *org, char *key);			  /* VIGENERE */
extern char *mdelvayo (char *org, char *ley);   /* MDELVAYO */
extern char *beale (char *org, char *key);      /* BEALE */
extern char *vernam (char *org, char *afile);			  /* VERNAM */
extern char *nihilist(char *org, char *key_a, char *key_b); /* NITHILIST */
extern char *playfair (char *org, char *key);			  /* PLAYFAIR */
extern char *bifid (char *org, char *key);			  /* BIFID */
extern char *usass(char *org, int pos);       /* USA S.S. */
extern char *railfence(char *org, int rail);   /* RAILFENCE */
extern char *purple(char *org, char *k_six, char *k_fast, char *k_middle, char *k_slow, char *k_mot);   /* PURPLE */
extern char *enigma (char *org, char *rot, char *ref, char *ring);  /* ENIGMA */
extern char *navajo(char *org);           /* NAVAJO */
extern char *morse (char *org);					  /* MORSE */
extern char *twosquare (char *org, char *key_a, char *key_b);
extern char *lewis (char *org, char *key);			  /* LEWIS */
extern char *alberti (char *org, char *key);			  /* ALBERTI */
extern char *feistel (char *org, char *key);			  /* FEISTEL */

/* Hashers */

char *encode_base64(int *org);						/*					*/
int *decode_base64(char *org);						/*	BASE64	*/
extern char *base64 (int *org);				  	  	/*					*/
unsigned long unixhash(char *org);        /* LINUX ELF HASH */
char *lfshift(char *org, int size);       /* PERSONAL LINEAR FORWARD SHIFT */
int hashpjw(char *org);                   /* PETER WEINBERGER'S HASH */
unsigned long sdbmh(char *org);           /* SDBM HASH */
unsigned long djb2(char *org);            /* DAN BERNSTEIN */
char XORhash( char *key, int len);        /* XOR HASH */
char *md5hash(char *org);                 /* MD5 */
